diff --git a/src/modules/rlm_sql/drivers/rlm_sql_firebird/rlm_sql_firebird.c b/src/modules/rlm_sql/drivers/rlm_sql_firebird/rlm_sql_firebird.c
index 13075a0f94a..5abf3cee23b 100644
--- a/src/modules/rlm_sql/drivers/rlm_sql_firebird/rlm_sql_firebird.c
+++ b/src/modules/rlm_sql/drivers/rlm_sql_firebird/rlm_sql_firebird.c
@@ -194,6 +194,29 @@ static int sql_num_rows(rlm_sql_handle_t *handle, rlm_sql_config_t *config)
 	return sql_affected_rows(handle, config);
 }
 
+/** Returns name of fields.
+ *
+ */
+static sql_rcode_t sql_fields(char const **out[], rlm_sql_handle_t *handle, UNUSED rlm_sql_config_t *config)
+{
+	rlm_sql_firebird_conn_t *conn = ((rlm_sql_firebird_conn_t *) handle->conn);
+	int		fields, i;
+	char const	**names;
+	
+	fields = conn->sqlda_out->sqld;
+	if (fields <= 0) return RLM_SQL_ERROR;
+
+	MEM(names = talloc_array(handle, char const *, fields));
+
+	for (i = 0; i < fields; i++) {
+		names[i] = conn->sqlda_out->sqlvar[i].sqlname;
+	} 
+	*out = names;
+
+
+	return RLM_SQL_OK;
+}
+
 /** Returns an individual row.
  *
  */
@@ -302,6 +325,7 @@ rlm_sql_module_t rlm_sql_firebird = {
 	.sql_num_rows			= sql_num_rows,
 	.sql_affected_rows		= sql_affected_rows,
 	.sql_fetch_row			= sql_fetch_row,
+	.sql_fields				= sql_fields,
 	.sql_free_result		= sql_free_result,
 	.sql_error			= sql_error,
 	.sql_finish_query		= sql_finish_query,
